#ifndef XML_FREEMIND_H
#define XML_FREEMIND_H


#include <QString>
#include <QXmlAttributes>

#include "file.h"
#include "mapcenterobj.h"
#include "mapeditor.h"


class parseFMHandler  : public QXmlDefaultHandler
{
public:
	parseFMHandler();
	~parseFMHandler();
	QString errorProtocol();
	bool startDocument();
	QString parseHREF(QString);
	bool startElement ( const QString&, const QString&,
                        const QString& eName, const QXmlAttributes& atts ); 
	bool   endElement ( const QString&, const QString&, const QString& ); 
	bool characters   ( const QString&);
	QString errorString();
	bool fatalError( const QXmlParseException&);
	void setMapEditor (MapEditor*);
	void setTmpDir (QString);
	void setInputFile (QString);
	void setLoadMode (const LoadMode &);
	bool readNodeAttr (const QXmlAttributes&);

private:
	QString     errorProt;
	enum State 
	{ 
		StateInit, 
		StateMap, 
		StateNode, 
		StateCloud,
		StateEdge, 
		StateIcon, 
		StateFont,
		StateArrowLink,
		StateHook,
		StateText
	 };
				 

	LoadMode loadMode;
	bool isVymPart;
	State state;			 
	State laststate;
	QList <State> stateStack;
	QString htmldata;
	int branchDepth; 
	NoteObj no;
	MapCenterObj* mc;
	MapEditor* me; 
	QString tmpDir; 
	QString inputFile;
}; 
#endif
